HDU 6205 card card card(展开字符串思想+思维)

97 篇文章 0 订阅

card card card

Time Limit: 8000/4000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 14    Accepted Submission(s): 5


Problem Description
As a fan of Doudizhu, WYJ likes collecting playing cards very much. 
One day, MJF takes a stack of cards and talks to him: let's play a game and if you win, you can get all these cards. MJF randomly assigns these cards into  n  heaps, arranges in a row, and sets a value on each heap, which is called "penalty value".
Before the game starts, WYJ can move the foremost heap to the end any times. 
After that, WYJ takes the heap of cards one by one, each time he needs to move all cards of the current heap to his hands and face them up, then he turns over some cards and the number of cards he turned is equal to the  penaltyvalue .
If at one moment, the number of cards he holds which are face-up is less than the  penaltyvalue , then the game ends. And WYJ can get all the cards in his hands (both face-up and face-down).
Your task is to help WYJ maximize the number of cards he can get in the end.So he needs to decide how many heaps that he should move to the end before the game starts. Can you help him find the answer?
MJF also guarantees that the sum of all "penalty value" is exactly equal to the number of all cards.
 

Input
There are about  10  test cases ending up with EOF.
For each test case:
the first line is an integer  n  ( 1n106 ), denoting  n  heaps of cards;
next line contains  n  integers, the  i th  integer  ai  ( 0ai1000 ) denoting there are  ai  cards in  i th  heap;
then the third line also contains  n  integers, the  i th  integer  bi  ( 1bi1000 ) denoting the "penalty value" of  i th  heap is  bi .
 

Output
For each test case, print only an integer, denoting the number of piles WYJ needs to move before the game starts. If there are multiple solutions, print the smallest one.
 

Sample Input
  
  
5 4 6 2 8 4 1 5 7 9 2
 

Sample Output
  
  
4
Hint
[pre] For the sample input: + If WYJ doesn't move the cards pile, when the game starts the state of cards is: 4 6 2 8 4 1 5 7 9 2 WYJ can take the first three piles of cards, and during the process, the number of face-up cards is 4-1+6-5+2-7. Then he can't pay the the "penalty value" of the third pile, the game ends. WYJ will get 12 cards. + If WYJ move the first four piles of cards to the end, when the game starts the state of cards is: 4 4 6 2 8 2 1 5 7 9 WYJ can take all the five piles of cards, and during the process, the number of face-up cards is 4-2+4-1+6-5+2-7+8-9. Then he takes all cards, the game ends. WYJ will get 24 cards. It can be improved that the answer is 4. **huge input, please use fastIO.** [/pre]

题解:
本次比赛a的第二题。。一开始还以为做不出来,后来尝试了一下居然ac了
思路:
由于是可以挪动的,所以我们先扩展一下字符串,也就是将数组从0到n-1复制一遍到n到2*n-1,然后我们扫一遍这个长度为2*n-1的数组,ans初始为0,每次加上上面的数组和下面的数组的差,如果ans是一个负数,那么就开始计算当前的最长长度和最长的值,否则继续。。然后扫到最后都还符合条件还要特判一下,还有就是如果当前的i大于了n,如果ans小于了0可以直接退出,或者是当前选择长度已经达到了n也可以退出
代码:

#include<iostream>
#include<cstring>
#include<stdio.h>
#include<math.h>
#include<string>
#include<stdio.h>
#include<queue>
#include<stack>
#include<map>
#include<vector>
#include<deque>
#include<algorithm>
using namespace std;
int a[2000005];
int b[2000005];
int main()
{
    int i,j,n,ans,d,tag,maxx,len,num;
    while(scanf("%d",&n)!=EOF)
    {
        for(i=0;i<n;i++)
        {
            scanf("%d",&a[i]);
            a[n+i]=a[i];
        }
        for(i=0;i<n;i++)
        {
            scanf("%d",&b[i]);
            b[n+i]=b[i];
        }
        ans=0;
        maxx=0;
        num=0;
        len=0;
        d=-1;
        for(i=0;i<2*n;i++)
        {
            num+=a[i];
            ans+=(a[i]-b[i]);
            len++;
            if(len>=n)
            {
                maxx=num;
                d=i-len+1;
                break;
            }
            if(ans<0)
            {
                if(num>maxx)
                {
                    maxx=num;
                    d=i;
                }
                if(i>n)
                    break;
                ans=0;
                num=0;
                len=0;
            }
        }
        printf("%d\n",d);
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 2
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 2
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值